package org.apache.xindice.client.corba.db;

//
// Holder class for : Data
//
// @author OpenORB Compiler
//
final public class DataHolder
		implements org.omg.CORBA.portable.Streamable
{
	//
	// Internal Data value
	//
	public byte[] value;

	//
	// Default constructor
	//
	public DataHolder()
	{ }

	//
	// Constructor with value initialisation
	// @param	initial	the initial value
	//
	public DataHolder( byte[] initial )
	{
		value = initial;
	}

	//
	// Read Data from a marshalled stream
	// @param	istream the input stream
	//
	public void _read( org.omg.CORBA.portable.InputStream istream )
	{
		value = DataHelper.read(istream);
	}

	//
	// Write Data into a marshalled stream
	// @param	ostream the output stream
	//
	public void _write( org.omg.CORBA.portable.OutputStream ostream )
	{
		DataHelper.write(ostream,value);
	}

	//
	// Return the Data TypeCode
	// @return a TypeCode
	//
	public org.omg.CORBA.TypeCode _type()
	{
		return DataHelper.type();
	}

}
