package org.apache.xindice.client.corba.db;

//
// Interface definition : DocumentSet
//
// @author OpenORB Compiler
//
public class _DocumentSetStub extends org.omg.CORBA.portable.ObjectImpl
		implements DocumentSet
{
	static final String[] _ids_list =
	{
		"IDL:org/apache/xindice/client/corba/db/DocumentSet:1.0", 
		"IDL:org/apache/xindice/client/corba/db/ServantManagement:1.0"
	};

	public String[] _ids()
	{
		return _ids_list;
	}

	private final static Class _opsClass = org.apache.xindice.client.corba.db.DocumentSetOperations.class;

	//
	// Operation hasMoreDocuments
	//
	public boolean hasMoreDocuments()
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("hasMoreDocuments",true);
					_input = this._invoke(_output);
					boolean _arg_ret = _input.read_boolean();
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("hasMoreDocuments",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.DocumentSetOperations _self = ( org.apache.xindice.client.corba.db.DocumentSetOperations ) _so.servant;
				try
				{
					return _self.hasMoreDocuments();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation getNextDocument
	//
	public org.apache.xindice.client.corba.db.EncodedBuffer getNextDocument(long stamp)
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("getNextDocument",true);
					org.apache.xindice.client.corba.db.TimestampHelper.write(_output,stamp);
					_input = this._invoke(_output);
					org.apache.xindice.client.corba.db.EncodedBuffer _arg_ret = org.apache.xindice.client.corba.db.EncodedBufferHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getNextDocument",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.DocumentSetOperations _self = ( org.apache.xindice.client.corba.db.DocumentSetOperations ) _so.servant;
				try
				{
					return _self.getNextDocument( stamp);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation remove
	//
	public void remove()
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("remove",true);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("remove",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.ServantManagementOperations _self = ( org.apache.xindice.client.corba.db.ServantManagementOperations ) _so.servant;
				try
				{
					_self.remove();
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

}
