package org.apache.xindice.client.corba.db;

//
// Exception definition : APIException
//
// @author OpenORB Compiler
//
public final class APIException extends org.omg.CORBA.UserException
{
	//
	// Exception member faultCode
	//
	public int faultCode;

	//
	// Exception member faultMessage
	//
	public String faultMessage;

	//
	// Exception member exceptionMessage
	//
	public String exceptionMessage;

	//
	// Default constructor
	//
	public APIException()
	{
		super( APIExceptionHelper.id() );
	}

	//
	// Constructor with fields initialization
	// @param	faultCode	faultCode exception member
	// @param	faultMessage	faultMessage exception member
	// @param	exceptionMessage	exceptionMessage exception member
	//
	public APIException( int faultCode, String faultMessage, String exceptionMessage )
	{
		super( APIExceptionHelper.id() );
		this.faultCode = faultCode;
		this.faultMessage = faultMessage;
		this.exceptionMessage = exceptionMessage;
	}

	//
	// Full constructor with fields initialization
	// @param	faultCode	faultCode exception member
	// @param	faultMessage	faultMessage exception member
	// @param	exceptionMessage	exceptionMessage exception member
	//
	public APIException( String orb_reason, int faultCode, String faultMessage, String exceptionMessage )
	{
		super( APIExceptionHelper.id() +" " +  orb_reason );
		this.faultCode = faultCode;
		this.faultMessage = faultMessage;
		this.exceptionMessage = exceptionMessage;
	}

}
