package org.apache.xindice.client.corba.db;

//
// Holder class for : Database
//
// @author OpenORB Compiler
//
final public class DatabaseHolder
		implements org.omg.CORBA.portable.Streamable
{
	//
	// Internal Database value
	//
	public org.apache.xindice.client.corba.db.Database value;

	//
	// Default constructor
	//
	public DatabaseHolder()
	{ }

	//
	// Constructor with value initialisation
	// @param	initial	the initial value
	//
	public DatabaseHolder( org.apache.xindice.client.corba.db.Database initial )
	{
		value = initial;
	}

	//
	// Read Database from a marshalled stream
	// @param	istream the input stream
	//
	public void _read( org.omg.CORBA.portable.InputStream istream )
	{
		value = DatabaseHelper.read(istream);
	}

	//
	// Write Database into a marshalled stream
	// @param	ostream the output stream
	//
	public void _write( org.omg.CORBA.portable.OutputStream ostream )
	{
		DatabaseHelper.write(ostream,value);
	}

	//
	// Return the Database TypeCode
	// @return a TypeCode
	//
	public org.omg.CORBA.TypeCode _type()
	{
		return DatabaseHelper.type();
	}

}
