package org.apache.xindice.client.corba.db;

//
// Interface definition : DatabaseManager
//
// @author OpenORB Compiler
//
public class DatabaseManagerPOATie extends DatabaseManagerPOA
{

	//
	// Private reference to implementation object
	//
	private DatabaseManagerOperations _tie;

	//
	// Private reference to POA
	//
	private org.omg.PortableServer.POA _poa;

	//
	// Constructor
	//
	public DatabaseManagerPOATie( DatabaseManagerOperations tieObject )
	{
		_tie = tieObject;
	}

	//
	// Constructor
	//
	public DatabaseManagerPOATie( DatabaseManagerOperations tieObject, org.omg.PortableServer.POA poa )
	{
		_tie = tieObject;
		_poa = poa;
	}

	//
	// Get the delegate
	//
	public DatabaseManagerOperations _delegate()
	{
		return _tie;
	}

	//
	// Set the delegate
	//
	public void _delegate( DatabaseManagerOperations delegate_)
	{
		_tie = delegate_;
	}

	//
	//
	//
	public org.omg.PortableServer.POA _default_POA()
	{
		if ( _poa != null )
		    return _poa;
		else
		    return super._default_POA();
	}

	//
	// Operation getName
	//
	public String getName()
		throws org.apache.xindice.client.corba.db.APIException
	{
		return _tie.getName();
	}

	//
	// Operation shutdown
	//
	public void shutdown()
	{
		_tie.shutdown();
	}

	//
	// Operation remove
	//
	public void remove()
	{
		_tie.remove();
	}

}
