package org.apache.xindice.client.corba.db;

//
// Interface definition : ServantManagement
//
// @author OpenORB Compiler
//
public class ServantManagementPOATie extends ServantManagementPOA
{

	//
	// Private reference to implementation object
	//
	private ServantManagementOperations _tie;

	//
	// Private reference to POA
	//
	private org.omg.PortableServer.POA _poa;

	//
	// Constructor
	//
	public ServantManagementPOATie( ServantManagementOperations tieObject )
	{
		_tie = tieObject;
	}

	//
	// Constructor
	//
	public ServantManagementPOATie( ServantManagementOperations tieObject, org.omg.PortableServer.POA poa )
	{
		_tie = tieObject;
		_poa = poa;
	}

	//
	// Get the delegate
	//
	public ServantManagementOperations _delegate()
	{
		return _tie;
	}

	//
	// Set the delegate
	//
	public void _delegate( ServantManagementOperations delegate_)
	{
		_tie = delegate_;
	}

	//
	//
	//
	public org.omg.PortableServer.POA _default_POA()
	{
		if ( _poa != null )
		    return _poa;
		else
		    return super._default_POA();
	}

	//
	// Operation remove
	//
	public void remove()
	{
		_tie.remove();
	}

}
